/**
 * 
 */
package org.richfaces;

import org.ajax4jsf.test.base.RichSeleniumTest;
import org.ajax4jsf.test.base.SeleniumTestBase;
import org.ajax4jsf.test.base.Templates;
import org.testng.annotations.AfterTest;
import org.testng.annotations.BeforeTest;
import org.testng.annotations.Parameters;
import org.testng.annotations.Test;

/**
 * @author Andrey Markavstov
 * 
 */
public class AjaxPollTest extends SeleniumTestBase implements RichSeleniumTest {

	public AjaxPollTest() {
		super("http", "localhost", "8080");
	}

	/**
	 * This method are invoking before selenium tests started
	 */
	@BeforeTest
	@Parameters( { "browser" })
	public void startSelenium(String browser) {
		super.startSelenium(browser);
	}

	/**
	 * This method are invoking after selenium tests completed
	 */
	@AfterTest
	public void stopSelenium() {
		super.stopSelenium();
	}
	
	@Test
	public void testAjaxPollComponent() {
		_testAjaxPollComponent(Templates.SIMPLE);
		_testAjaxPollComponent(Templates.DATATABLE);
	}
	
	private void _testAjaxPollComponent(Templates template) {
		renderPage(getTestUrl(), template);
		String parentId = getParentId() + "_form:";
		String pollId = parentId + "poll";
		String inputId = parentId + "_value";
		
		writeStatus("Polling in progress...");
		AssertValueEquals(inputId, "1");
		pause(1500, pollId);
		AssertValueNotEquals(inputId, "1");
		waiteForCondition("document.getElementById('"+inputId+"').value == 7", 7000);
		
		pause(1500, pollId);
		writeStatus("Polling should be stopped...");
		AssertValueEquals(inputId, "7");
		AssertTextEquals(parentId + "_text", "Polling");

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.ajax4jsf.test.base.RichSeleniumTest#getTestUrl()
	 */
	public String getTestUrl() {
		return "/faces/pages/ajaxPoll/ajaxPollTest.xhtml";
	}

}
