package org.richfaces;

import org.ajax4jsf.test.base.SeleniumTestBase;
import org.ajax4jsf.test.base.Templates;
import org.testng.annotations.AfterTest;
import org.testng.annotations.BeforeTest;
import org.testng.annotations.Parameters;
import org.testng.annotations.Test;

public class KeepAliveTest extends SeleniumTestBase {

    public KeepAliveTest() {
        super("http", "localhost", "8080");
    }

    /**
     * This method are invoking before selenium tests started
     */
    @BeforeTest
    @Parameters( { "browser" })
    public void startSelenium(String browser) {
        super.startSelenium(browser);
    }

    /**
     * This method are invoking after selenium tests completed
     */
    @AfterTest
    public void stopSelenium() {
        super.stopSelenium();
    }

    @Test
    public void testKeepAliveComponent() throws Exception {
        _testKeepAliveComponent(Templates.DATATABLE);
    }

    private void _testKeepAliveComponent(Templates template) {
        renderPage("/faces/pages/keepAlive/keepAliveTest.xhtml", template);

        String parentId = getParentId();

        String sumElemId = parentId + "sum";
        AssertValueEquals(sumElemId, "0");
        String addButtonId = parentId + "form:add";
        String addAjaxButtonId = parentId + "form:addAjax";

        writeStatus("The sum has to be increased by 5 twice");

        clickById(addButtonId);
        clickById(addButtonId);
        delay(3000);
        AssertValueEquals(sumElemId, "10");

        writeStatus("The sum has to be increased by 5 twice again");

        clickById(addAjaxButtonId);
        clickById(addAjaxButtonId);
        waitForAjaxCompletion();
        AssertValueEquals(sumElemId, "20");

        writeStatus("Test ajax only regime ... ");

        String sumAjaxOnlyElemId = parentId + "sumAjaxOnly";
        AssertValueEquals(sumAjaxOnlyElemId, "0");
        addButtonId = parentId + "formAjaxOnly:add";
        addAjaxButtonId = parentId + "formAjaxOnly:addAjax";

        writeStatus("State is not saved between full submits. The sum always is 5");

        clickById(addButtonId);
        clickById(addButtonId);
        delay(3000);
        AssertValueNotEquals(sumAjaxOnlyElemId, "10");

        writeStatus("Ajax request! The sum has to be increased by 5 twice");

//      This test doesn't pass! Bug?!

//      clickById(addAjaxButtonId);
//      clickById(addAjaxButtonId);
//      waitForAjaxCompletion();
//      AssertValueEquals(sumAjaxOnlyElemId, "10");
    }
}
